'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : [select VIEW...EDITOR OPTIONS]                    *
'*  Notice  : Copyright (c) 2010 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 18.09.2010                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
Device = 12F683

Xtal = 8

Config FCMEN_OFF, IESO_OFF, BOD_OFF, CPD_OFF, CP_OFF, MCLRE_OFF, PWRTE_OFF, WDT_ON, HS_OSC

Symbol MAXTRY = 15       ; number of watchdog restart to calibrate loop counter

Dim   ctr As Byte ;           // number of loops between two watchdog resets
Dim   previous As Byte ;      // previous value of ctr
Dim   calibr As Byte ;        // calibration value when oscillator runs free
Dim   restarts As Byte ;      // number of watchdog restarts
Dim   en As Byte ;            // enable flag, allows detection


'/*
' * main loop
' */
main:
'        {
'        unsigned char   i ;
        

'        /*
'         * configure GPIO as digital port
'         */
        CMCON0 = 7 ;
        ANSEL = 0 ;
        TRISIO = 0 ;
        GPIO = 0 ;

'        /*
'         * power up ?
'         */
        If STATUS.4 = 1 Then
'                /*
'                 * yes, init variables
'                 */
                 restarts = 0 ;
                 calibr = 1 ;
        EndIf
'        /*
'         * watchdog reset counter
'         */
        If restarts < 255 Then restarts = restarts + 1 ;

'        /*
'         * if counter differs too much from calibration value
'         */
        If previous ^ ctr > calibr Then 
'                /*
'                 * turn detect LED on
'                 */
                GPIO.0 = en ;
                
'                /*
'                 * if not on power up
'                 */
                If STATUS.4 = 0 Then
'                        /*
'                         * while in calibration mode
'                         */
                        If restarts < MAXTRY Then
'                                /*
'                                 * shift calibration value
'                                 * and wait a little bit
'                                 */
                                calibr = calibr << 1 ;
                                DelayMS 5 ;
                               EndIf
                        EndIf
                Else
'                        {
'                        /*
'                         * turn detect LED off
'                         */
                        GPIO.0 = 0 ;
                EndIf

'        /*
'         * save last counter
'         */
        previous = ctr ;

'         * is calibration over ?
'         */
        If restarts > MAXTRY Then
'                 * yes, turn calibrate LED off
'                 * and set enable flag
'                 */
                GPIO.1 = 0 ;
                en = 1 ;
        Else
'                /*
'                 * no, turn calibrate LED on
'                 * and clear enable flag
'                 */
                GPIO.1 = 1 ;
                en = 0 ;
        EndIf

'        /*
'         * set watchdog prescaler
'         */
        OPTION_REG = 0b11111001 ;
        
'        /*
'         * start counter, to be interrupted by watchdog
'         */
        ctr = 0 ;
loop:       
               Inc ctr ;
GoTo loop               
End
